// eslint-disable-next-line @typescript-eslint/no-unused-vars
import {
  assignNewGraphQueryResult,
  useAppDispatch,
  useGraphQueryResult,
} from '@graphpolaris/shared/data-access/store';
import React, { useEffect } from 'react';
import styles from './app.module.scss';
import ReactJSONView from 'react-json-view';
import NxWelcome from './nx-welcome';

const RawJSONVis = React.memo(() => {
  const graphQueryResult = useGraphQueryResult();
  console.log('update rawjson');

  useEffect(() => {
    console.log('update rawjson useEffect');
  }, [graphQueryResult]);

  useEffect(() => {
    return () => {
      console.log('unloaded RawJSONVis');
    };
  }, []);

  return (
    <div style={{ overflowY: 'auto' }}>
      <div
        style={{
          marginTop: '40px',
          paddingLeft: '30px',
        }}
      >
        <ReactJSONView
          src={graphQueryResult}
          collapsed={1}
          quotesOnKeys={false}
          displayDataTypes={false}
        />
      </div>
    </div>
  );
});

export function App() {
  const dispatch = useAppDispatch();

  return (
    <>
      <div>
        <button
          onClick={() =>
            dispatch(
              assignNewGraphQueryResult({
                nodes: [
                  { id: 'agent/007', attributes: { name: 'Daniel Craig' } },
                ],
                links: [],
              })
            )
          }
        >
          Load in mock result
        </button>
        <button
          onClick={() =>
            dispatch(assignNewGraphQueryResult({ nodes: [], links: [] }))
          }
        >
          Remove mock result
        </button>
      </div>
      <RawJSONVis />
      <NxWelcome title="graphpolaris" />
      <div />
    </>
  );
}

export default App;
